// Fait sous Ubuntu
// LarynxArduino16.pde
// OuvertureXml.pde
// Chain.pde
// TextIntro.pde
// 
// Gerard Paresys Guy Kayser
// 1 10 2015
// Processing 2.0.3
//
// = Larynx13.pde avec nouveau drehu256.png
//                avec library serial pour communiquer avec Arduino
//
// Utilise la library minim de Damien Di Fede incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// Utilise la "contributed library" ControlP5 by Andreas Schlegel
// http://www.sojamo.de/libraries/oscp5/
//
// Utilise la library serial
// pour communiquer avec une carte Arduino
//
// Utilise http://www.openprocessing.org/sketch/77718
// "Worm" de Adam Lastowka
//
// PeasyCam: Souris Molette           : Zoom
//           Souris Clic droit + Drag : Zoom      
//           Souris Clic + Drag       : Rotation      
//           Souris 2 x Clic          : Reset position
//           Souris cmd + Clic + Drag : Translate (MacOS)
// Touche Clavier:
//       A Retour Accueil
//       Z Retour au debut du fichier
//       R Rouge Couleur relief On / Off
//       V Vert  Couleur relief On / Off
//       B Bleu  Couleur relief On / Offs
//       S Sauve l'ecran (format png) nombre = Numero frame
//       L Lumiere              On/Off
//       T Affiche Transcription <-> Traduction
//       W Web site Corpus de la parole
//  Espace Pause
// Souris Clic en dehors des 9 langues: Intro
//
// Le dossier data doit contenir les fichiers:
//   Aller-Light-120.vlw
//   ... 76 fichiers en tout
//
// Une carte Arduino doit etre connectee avec le sketch Arduino5Analog2Digital.ino
//

import ddf.minim.*;         // pour AudioPlayer
import peasy.*;
import controlP5.*;
import processing.serial.*;

import java.awt.*;
import java.lang.Object ;
import java.awt.Color ;
import javax.swing.JFrame;  // pour Full Screen Background

String  NomFichierXML = "maore.xml"; // les 5 fichiers "maore..." doivent etre dans le dossier data

boolean Lumiere       = true;  // Touche L  Lumiere On/Off
boolean TransTrad     = false;  // Touche T Affiche Transcription <-> Traduction
Boolean WormEnCouleur = false;
boolean Verbose       = false;
Boolean HeigtMapEnCouleurR = false;
Boolean HeigtMapEnCouleurV = false;
Boolean HeigtMapEnCouleurB = false;

color   CouleurBackground = color(0); // Noir
color   CouleurTexteRuban = color(255, 255, 255);  // Vert: color(0, 255, 0)
color   CouleurTexteBas   = color(255, 255, 255);  // Rouge: color(255, 0, 0)
color   CouleurWorm       = color(255, 0, 0);      // Rouge: color(255, 0, 0)

int RubanMini  = 10;
int RubanMaxi  = 80;
int HauteurMaxi= 20; //Maxi Erection

XML[] Traduction, Transcription;
int NombreSegment;
String[] LignesPitch;
String[] LignesIntensity;
float[] LignePitch, LigneIntensity;
boolean FichierOuvert = false;
boolean PlayerOuvert = false;
boolean FinVoix = true;

Minim minim;
AudioPlayer player;

PeasyCam pcam;
CameraState  pcamstate;

float[][] hm  = new float[256][256]; // hm[x][y] = brightness(Image)
float[][] hm2 = new float[256][256];
int hmlengthdemi = hm.length / 2;

float MM = 2;         // MM = diametre du worm
boolean Pause = false;
float Temps, TempsPause = 0, TempsDebutPause = 0, Temps2;
PFont  FontTexte, FontRuban;


Maker Worm = new Maker(); 
float wormTemp;
int   x, y, Alea;
float Distance, h;

PImage Image1;
color MonPixel;

int IndexXML = 0, Segment;
float xmin, xmax;  // Temps en seconde
String Content1 = "", Content2 = "", Content = "", Nom = "Accueil";
float Intensite, Pitche = 100, PitcheMini = 1000, PitcheMaxi = 0;
float  FacteurIntensity, FacteurPitch;

ControlP5 cp5;

StringDict WWW;

Serial Arduino;        // The serial port
boolean PremiereFois = true;
String[] ListeArduino = new String[7];
float[] InArduino = {
  512, 512, 512, 512, 512, 0, 0
};
float[] InArduinoAvant = {
  512, 512, 512, 512, 512, 0, 0
};
// float ArduinoRotateX, ArduinoRotateY, ArduinoRotateZ, ArduinoDistance;
float ArduinoDistance;

int NumeroVoix = 9, NumeroVoixAvant = 9;

void setup() {  
  // size(1024, 768, P3D); // P3D  OPENGL
  // frame.setBackground(new java.awt.Color(0, 0, 0));
  // setPresentBG (0, 0, 0) ;
  size(displayWidth, displayHeight, P3D); // Pour FullScreen

  minim = new Minim(this);

  pcam = new PeasyCam(this, width/2, height/2, 0, 600); // PeasyCam(PApplet parent, double lookAtX, double lookAtY, double lookAtZ, double distance);
  pcam.setMinimumDistance(50);
  pcam.setMaximumDistance(1000);
  pcam.rotateX(-PI/4);
  pcamstate = pcam.getState();

  noStroke();
  frameRate(60);
  // frameRate(2); // A mettre pour mieux comprendre

  // FontTexte = loadFont("ArialMT-12.vlw");
  // FontTexte = createFont("Arial", 12);        
  // FontTexte = loadFont("ArialMT-12.vlw");              
  // FontTexte = createFont("Arial", 84);              
  FontTexte = createFont("Arial", 12);              
  FontRuban = loadFont("Aller-Light-120.vlw"); // Font taille 120
  // FontIntro = createFont("Arial", 14);
  // FontIntro = loadFont("ArialMT-28.vlw");
  // FontIntro = createFont("Arial", 84);
  // FontIntro = createFont("Arial", 14);
  FontIntro = loadFont("OpenSans-14.vlw");

  // Chain ------------------------------------------------------------------------
  Ruban = "A";
  reversed = reverseWords(Ruban);
  chain = new ArrayList();
  for (int i = 0; i < num; i++) chain.add(new Chain(i));
  // Chain ------------------------------------------------------------------------

  //  cp5 = new ControlP5(this);
  //
  //  cp5.addButton("cemuhi")
  //    .setPosition(101, 100)
  //      .setImages(loadImage("cemuhi_accueilA.jpg"), loadImage("cemuhi_accueilB.jpg"), loadImage("cemuhi_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("guadeloupe")
  //    .setPosition(101, 300)
  //      .setImages(loadImage("guadeloupe_accueilA.jpg"), loadImage("guadeloupe_accueilB.jpg"), loadImage("guadeloupe_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("occitan")
  //    .setPosition(101, 500)
  //      .setImages(loadImage("occitan_accueilA.jpg"), loadImage("occitan_accueilB.jpg"), loadImage("occitan_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("reunion")
  //    .setPosition(375, 100)
  //      .setImages(loadImage("reunion_accueilA.jpg"), loadImage("reunion_accueilB.jpg"), loadImage("reunion_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("maore")
  //    .setPosition(375, 300)
  //      .setImages(loadImage("maore_accueilA.jpg"), loadImage("maore_accueilB.jpg"), loadImage("maore_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("picard")
  //    .setPosition(375, 500)
  //      .setImages(loadImage("picard_accueilA.jpg"), loadImage("picard_accueilB.jpg"), loadImage("picard_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("franceA")
  //    .setPosition(649, 100)
  //      .setImages(loadImage("franceA_accueilA.jpg"), loadImage("franceA_accueilB.jpg"), loadImage("franceA_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("kabyle")
  //    .setPosition(649, 300)
  //      .setImages(loadImage("kabyle_accueilA.jpg"), loadImage("kabyle_accueilB.jpg"), loadImage("kabyle_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("drehu")
  //    .setPosition(649, 500)
  //      .setImages(loadImage("drehu_accueilA.jpg"), loadImage("drehu_accueilB.jpg"), loadImage("drehu_accueilA.jpg"))
  //        .updateSize();
  //  cp5.addButton("bandeau")
  //    .setPosition(0, 0)
  //      .setImages(loadImage("accueil_bandeau.jpg"), loadImage("accueil_bandeau.jpg"), loadImage("accueil_bandeau.jpg"))
  //        .updateSize();      
  //  cp5.setAutoDraw(false);

  //  File Fichier = new File(dataPath(NomFichierXML));
  //  if (Fichier.exists()) {
  //    Ouverture(NomFichierXML);
  //    Nom = split(Fichier.getName(), '.')[0];
  //  }
  //  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");

  WWW = new StringDict();
  WWW.set("cemuhi", "http://corpusdelaparole.tge-adonis.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-CAM_TORTUE_SOUND");
  WWW.set("drehu", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-DHV_MU_SOUND");
  WWW.set("franceA", "http://eslo.huma-num.fr/CorpusEslo/html/ecoute/real?idEnregistrement=1001&mode=enregistrement&idTranscription=553");
  WWW.set("guadeloupe", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-GCF_1022_SOUND");
  WWW.set("kabyle", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-KAB_LDF1_SOUND");
  WWW.set("maore", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-SWB_HOMME_SOUND");
  WWW.set("occitan", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-FRA_32-DEMU2_SOUND");
  WWW.set("picard", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-PCD_DELSALLE_4_SOUND");
  WWW.set("reunion", "http://corpusdelaparole.huma-num.fr/spip.php?article30&ldf_id=oai:crdo.vjf.cnrs.fr:crdo-RCF_COCOTTE_SOUND");

  // List all the available serial ports
  println(Serial.list());
  // I know that the first port in the serial list on my mac
  // is always my  Arduino, so I open Serial.list()[0].
  // Open whatever port is the one you're using.
  Arduino = new Serial(this, Serial.list()[0], 9600);
  // don't generate a serialEvent() unless you get a newline character:
  Arduino.bufferUntil('\n');
  Temps2 = millis();
  // smooth(8);
}

void draw() {
  background(0);  // 0 
  // image(Image1, 0, 0, width, height);
  hint(DISABLE_DEPTH_TEST);
  pcam.beginHUD();
  // cp5.draw();
  if (Intro) TexteIntro();
  pcam.endHUD();
  hint(ENABLE_DEPTH_TEST);

  // if (Lumiere) lights();
  // if (Lumiere) pointLight(255, 250, 200, 0, 0, 1000);
  if (Lumiere) pointLight(250, 245, 240, 500, 500, 1000);

  if (! Pause) Temps = (millis() - TempsPause) / 1000.0; //temps en ms

  if (FichierOuvert) {
    if (IndexXML < NombreSegment) { // 8 2 2015
      if (Temps > xmax) {                        // Passage au segment suivant
        IndexXML = IndexXML + 1;
        if (Verbose) println();
        // if (Verbose) println("IndexXML = " + IndexXML);
        if (IndexXML < NombreSegment) Content = Traduction[IndexXML].getContent();
        if (IndexXML < NombreSegment) Content2 = Transcription[IndexXML].getContent();
        if (Content == null) IndexXML = IndexXML + 1;
        else if (Content.equals("_") == true) IndexXML = IndexXML + 1;//Elimination des caracteres _ qui separe les segments
        // else if ((Temps > xmin) && ! Pause) {
        else if (! Pause) {
          if (IndexXML < NombreSegment) Segment = Traduction[IndexXML].getInt("n"); 
          if (IndexXML < NombreSegment) xmin = Traduction[IndexXML].getFloat("xmin");
          if (IndexXML < NombreSegment) xmax = Traduction[IndexXML].getFloat("xmax");
          Content1 = trim(Content);
          Content2 = trim(Content2);
          println(Content1);
          // println(Content2);
          // Chain ------------------------------------------------------------------------
          if (TransTrad) Ruban = Content1;    // Traduction
          else           Ruban = Content2;    // Transcription

          reversed = reverseWords(Ruban);

          chain = new ArrayList();         // Efface chain
          for (int i = 0; i < num; i++) chain.add(new Chain(i));
          // Chain ------------------------------------------------------------------------
        }
      }
      if (int(Temps * FacteurIntensity) < LignesIntensity.length) { 
        LigneIntensity = float(split(LignesIntensity[int(Temps * FacteurIntensity)], "   ")); 
        Intensite = LigneIntensity[1];
        Intensite = (Intensite - 40) / 12;
        Intensite = max(Intensite, 0);
        // println("Temps = " + Temps + "      Intensite = " + Intensite);
      } 
      if (int(Temps * FacteurPitch) < LignesPitch.length) { //le retour du pitch voir Corpus35P2.pde
        LignePitch = float(split(LignesPitch[int(Temps * FacteurPitch)], "   "));
        if (! Float.isNaN(LignePitch[0]) && ! Float.isNaN(LignePitch[1])) Pitche = LignePitch[1];
        MM = ((Pitche - 75) / 85) + 2; // 2 .. 7
        // println("MM = "+ MM);
      }
    } else {
      Pause = true;
      FinVoix = true;
    }

    pushMatrix();
    translate(width/2, height/2);
    if (! Pause) temGen();

    // stroke(128);
    noStroke();
    scale(1.8);
    // if (frameCount % 3 == 1) {
    background(CouleurBackground);  // 0
    paintLandscape();
    // }
    // println("frameCount % 3 = " + frameCount % 3);
    scale(0.5);

    // Lissage();

    textFont(FontTexte, 12); 
    fill(CouleurTexteBas); // fill(0, 255, 0); // Texte vert
    textAlign(CENTER);
    translate(-200, 0, 30); //translate(-200, 0, 60)
    if (TransTrad) text(Content2, 0, 260, 400, 100); // Transcription
    else text(Content1, 0, 260, 400, 100);          // Traduction
    popMatrix();

    // Chain ------------------------------------------------------------------------
    pushMatrix();
    // translate(0, 0, 70);
    translate(Worm.x, Worm.y, Intensite + 35);
    // noStroke(); // Commenter pour voir le dessin du ruban
    if (! Pause) {
      for (int i =0; i < chain.size (); i++) {
        Chain cc  = (Chain)chain.get(i);
        cc.update();
      }
    }
    for (int i =chain.size ()-1; i > 0; i--) {
      Chain cc  = (Chain)chain.get(i);
      cc.draww();
    }
    popMatrix();
    // Chain ------------------------------------------------------------------------
    //    pcam.rotateX(ArduinoRotateX);
    //    pcam.rotateY(ArduinoRotateY);
    //    pcam.rotateZ(ArduinoRotateZ);
    //    pcam.setDistance(InArduino[3] + 100);
    if (InArduino[6] == 1) HeigtMapEnCouleurR = !HeigtMapEnCouleurR; // Heightmap Rouge
  }
  frame.setTitle(Nom + "     " + int(Temps * 10) / 10.0 + " sec     " + int(10 * frameRate) / 10.0 + " fps");
}

void keyPressed() {
  //  if (Intro) {
  //    Intro = false;
  //    Nom = "Information";
  //    cp5.show();
  //  }
  if (FinVoix) {
    FinVoix = false;
    Fini();
  }
  if ( key == ' ') {  // barre d'espace Pause
    if (FichierOuvert) {
      Pause = !Pause;
      if (Pause) {
        player.pause();
        TempsDebutPause = millis();
      } else {
        player.play();
        TempsPause = TempsPause + millis() - TempsDebutPause;
      }
    }
  }
  // else if ( key == 'e' || key == 'E' ) Lissage(); // Erosion Lissage
  else if ( key == 'z' || key == 'Z' ) {
    if (FichierOuvert) {
      generateLandscape();
      Lissage();
      Lissage();
      xmax = 0;
      IndexXML = -1;
      Pause = false;
      TempsPause = millis();
      PlayerAudioDebut();
    }
  }
  //  else if ( key == 'c' || key == 'C' ) WormEnCouleur = !WormEnCouleur;  // Touche C Couleur Worm On / Off
  else if ( key == 's' || key == 'S' ) saveFrame(Nom + "-" + frameCount + ".png"); // S Sauve l'ecran
  else if ( key == 'l' || key == 'L' ) Lumiere = !Lumiere;     // Touche L  Lumiere On/Off
  else if ( key == 't' || key == 'T' ) TransTrad = !TransTrad; // Touche T  Affiche Transcription <-> Traduction
  else if ( key == 'r' || key == 'R' ) HeigtMapEnCouleurR = !HeigtMapEnCouleurR; // Heightmap Rouge
  else if ( key == 'v' || key == 'V' ) HeigtMapEnCouleurV = !HeigtMapEnCouleurV; // Heightmap Vert
  else if ( key == 'b' || key == 'B' ) HeigtMapEnCouleurB = !HeigtMapEnCouleurB; // Heightmap Bleu
  else if ( key == 'a' || key == 'A' ) Fini(); // Retour à l'accueil
  else if ( key == 'w' || key == 'W' ) {
    // if (FichierOuvert && (WWW.get(Nom) != null)) open(WWW.get(Nom)); // Site corpusdelaparole
    if (FichierOuvert && (WWW.get(Nom) != null)) link(WWW.get(Nom), "_new"); // Site corpusdelaparole
  }
}

void generateLandscape() {
  Image1 = loadImage(NomFichierCarte);
  Image1.loadPixels();
  HeightMap();
}

void HeightMap() {
  for ( x = 0; x < hm.length; x++) {
    // for ( y = 0; y < hm.length; y++) hm[x][y] = brightness(Image1.pixels[x + (y * hm.length)])/ 8.f;
    for ( y = 0; y < hm.length; y++) hm[x][y] = max(min(brightness(Image1.pixels[x + (y * hm.length)])/ 8.f, 100), 0);
  }
}

void temGen() {
  //  Worm.x += sin(Worm.wormTheta)*2;
  //  Worm.y += cos(Worm.wormTheta)*2;
  Worm.x += sin(Worm.wormTheta);
  Worm.y += cos(Worm.wormTheta);
  Worm.wormTheta += Worm.wormThetaDelta;
  Worm.wormThetaDelta += random(-0.1, 0.1);
  Worm.wormThetaDelta /= 1.50; // 1.30 // 1.05 le worm tourne beaucoup 1.25 tourne peu 
  // println("Worm.wormTheta = " + Worm.wormTheta + "    Worm.x = " + Worm.x  + "    Worm.wormThetaDelta = " + Worm.wormThetaDelta);
  // + random(-0.1, 0.1) pour eviter l'erection du worm
  if      (Worm.x >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI + random(-0.1, 0.1);
  else if (Worm.x < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI + random(-0.1, 0.1);
  else if (Worm.y >   hmlengthdemi - 10) Worm.wormTheta = Worm.wormTheta - HALF_PI + random(-0.1, 0.1);
  else if (Worm.y < - hmlengthdemi + 10) Worm.wormTheta = Worm.wormTheta - HALF_PI + random(-0.1, 0.1);  

  // Alea = int(random(hm.length));

  x = int(Worm.x + hmlengthdemi);
  y = int(Worm.y + hmlengthdemi);
  h = Intensite * 3.9; // 4.4  13.0  h = 20

  x = max(min(x, 255), 0);
  y = max(min(y, 255), 0);

  hm[x][y] = min(hm[x][y] + h*1.5, HauteurMaxi);
  x = x - 1;
  hm[x][y] = min(hm[x][y] + h, HauteurMaxi);
  x = x + 2;
  hm[x][y] = min(hm[x][y] + h, HauteurMaxi);
  x = x - 1;
  y = y - 1;
  hm[x][y] = min(hm[x][y] + h, HauteurMaxi);
  y = y + 2;
  hm[x][y] = min(hm[x][y] + h, HauteurMaxi);

  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      Distance = dist((x - hmlengthdemi) / MM, (y - hmlengthdemi) / MM, Worm.x / MM, Worm.y / MM);
      if (Distance < 3) {
        hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1]) / 5.9315;
        // hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/5.9378;//kabyle-2172.png,guadeloupe-2118.png
        // hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/5.9278;//baude_fr-1971.png
        // hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;

        // Image1.pixels[x + (y * hm.length)] = color(hm2[x][y] * 8);
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] * 8)+255, (hm2[x][y] * 8), (hm2[x][y] * 8));
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] *8), 0, 0);
        // Image1.pixels[x + (y * hm.length)] = color((hm2[x][y] * 16), (hm2[x][y] * 8), (hm2[x][y] * 8));

        //if (WormEnCouleur)  Image1.pixels[x + (y * hm.length)] = color(red(MonPixel)+random(255), green(MonPixel)+random(255), blue(MonPixel)+random(255),150);
        //        if (WormEnCouleur) Image1.pixels[x + (y * hm.length)] = color(0, (hm2[x][y] *8), 0); // Pour worm en couleur
        //        else Image1.pixels[x + (y * hm.length)] = color(hm2[x][y] * 8); // 6 1 2015 Pour worm en couleur
      }
    }
  }
  for ( x = 1; x < hm.length-1; x++) {
    for ( y = 1; y < hm.length-1; y++) {
      Distance = dist((x - hmlengthdemi) / MM, (y - hmlengthdemi) / MM, Worm.x / MM, Worm.y / MM);
      if (Distance < 3) {
        hm[x][y] = hm2[x][y];
      }
    }
  }
  // HeightMap();
  // Image1.updatePixels();
  // Lissage();
}

void paintLandscape() {
  for ( x = 3; x < hm.length-5; x++) {
    beginShape(QUADS);
    for ( y = 3; y < hm.length-5; y++) {
      //  fill(abs(4*hm[x][y]), 255, 255);//origin

      //  if (HeigtMapEnCouleurR) fill((hm2[x][y]*16), (hm2[x][y] *2), (hm2[x][y]*2));//RVB
      //  else if (HeigtMapEnCouleurV) fill((hm2[x][y]*2), (hm2[x][y] *16), (hm2[x][y]*2));//RVB
      //  else if (HeigtMapEnCouleurB) fill((hm2[x][y]*2), (hm2[x][y] *2), (hm2[x][y]*24));//RVB
      //  else if (HeigtMapEnCouleurB) fill((hm2[x][y]*2), (hm2[x][y] *2), (hm2[x][y]*16));//RVB
      //  fill(232, 220, 108);
      //  else fill(Image1.pixels[x + (y * hm.length)]);

      if (HeigtMapEnCouleurR) fill((hm2[x][y] * 16), (hm2[x][y] * 2), (hm2[x][y] * 2));//RVB
      else if (HeigtMapEnCouleurV) fill((hm2[x][y]*2), (hm2[x][y] * 16), (hm2[x][y]*2));//RVB
      // else if (HeigtMapEnCouleurB) fill((hm2[x][y]*2), (hm2[x][y] *2), (hm2[x][y]*24));//RVB
      else if (HeigtMapEnCouleurB) fill((hm2[x][y]*2), (hm2[x][y] *2), (hm2[x][y]*20));//RVB
      // fill(232, 220, 108);
      // else fill(Image1.pixels[x + (y * hm.length)]); // Pour worm en couleur
      // else fill((hm2[x][y] * 6.8), (hm2[x][y] * 6.8), (hm2[x][y] * 6.8));//RVB 6 2 75
      else fill((hm2[x][y] *12), (hm2[x][y] * 12), (hm2[x][y] * 12));//RVB 6 2 75

      vertex(x     - hmlengthdemi, y     - hmlengthdemi, hm[x]  [y]);
      vertex(x + 1 - hmlengthdemi, y     - hmlengthdemi, hm[x+1][y]);
      vertex(x + 1 - hmlengthdemi, y + 1 - hmlengthdemi, hm[x+1][y+1]);
      vertex(x     - hmlengthdemi, y + 1 - hmlengthdemi, hm[x]  [y+1]);
    }
    // endShape(CLOSE);
    endShape();
  }
}

void Lissage() {
  println("Lissage");
  println("hm.length = " + hm.length);
  if (hm.length == 256) {
    for ( x = 1; x < hm.length-1; x++) {
      for ( y = 1; y < hm.length-1; y++) {
        hm2[x][y] = (hm[x][y]*2 + hm[x+1][y] + hm[x-1][y] + hm[x][y+1] + hm[x][y-1])/6;
      }
    }
    //    for ( x = 1; x < hm.length-1; x++) {
    //      for ( y = 1; y < hm.length-1; y++) {
    for ( x = 0; x < hm.length; x++) {
      for ( y = 0; y < hm.length; y++) {
        hm[x][y] = hm2[x][y];
        // hm[x][y] = max(min(hm2[x][y], 30), 0);
      }
    }
  }
}

class Maker {
  float x;
  float y;
  float wormTheta;
  float wormThetaDelta;
}

void FinOuverture() {
  player = minim.loadFile(NomFichierAudio, 1024);
  PlayerOuvert = true;
  FichierOuvert = true;
  FinVoix = false;
  pcam.setState(pcamstate);
  HeigtMapEnCouleurR = false;
  HeigtMapEnCouleurV = false;
  HeigtMapEnCouleurB = false;
  xmax = 0;
  IndexXML = -1;
  FacteurIntensity = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 
  FacteurPitch = LignesPitch.length / LignePitch[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 
  Lissage();
  // Lissage();
  player.play();
  TempsPause = millis();
}

void PlayerAudioDebut() {
  if (PlayerOuvert) player.close();
  player = minim.loadFile(NomFichierAudio, 1024);
  PlayerOuvert = true;
  player.play();
  TempsPause = millis();
}

void Fini() {
  Fini2();
  // Nom = "Accueil";
  // cp5.show();
}

void Fini2() {
  // println("Fini");
  Pause = false;
  TempsPause = millis();
  FichierOuvert = false;
  if (PlayerOuvert) player.close();
  PlayerOuvert = false;
  xmax = 0;
  IndexXML = -1;
}

//void setPresentBG (int r, int g, int b) {
//  ((JFrame) frame).getContentPane().setBackground(new Color(r, g, b));
//}

//public void controlEvent(ControlEvent theEvent) {
//  // println(theEvent.getController().getName());
//  Nom = theEvent.getController().getName();
//  // println("EEEEE public void controlEvent(ControlEvent theEvent)");
//  if (Nom != "bandeau") {
//    cp5.hide();
//    Ouverture(Nom + ".xml");
//  } 
//  else {
//    cp5.hide();
//    Intro = true;
//  }
//}

void serialEvent (Serial Arduino) {
  String inStringArduino = Arduino.readStringUntil('\n');  // get the ASCII string
  println("inStringArduino = " + inStringArduino);
  // if ((inStringArduino != null) && !PremiereFois) {
  if (inStringArduino != null) {
    ListeArduino = split(inStringArduino, '\t');
    if (ListeArduino.length == 7) {
      println("ListeArduino.length = " + ListeArduino.length);
      //      println("ListeArduino[0] = " + ListeArduino[0]);
      //      println("ListeArduino[1] = " + ListeArduino[1]);
      //      println("ListeArduino[2] = " + ListeArduino[2]);
      //      println("ListeArduino[3] = " + ListeArduino[3]);
      for (int i = 0; i < 7; i = i+1) {
        ListeArduino[i] = trim(ListeArduino[i]);
        InArduinoAvant[i] = InArduino[i];
        InArduino[i] = float(ListeArduino[i]);
        //        if (InArduino[i] >  10) InArduino[i] =  10;
        //        if (InArduino[i] < -10) InArduino[i] = -10;
      }
      // println("Arduino = " + InArduino[0] + "  " + InArduino[1] + "  " + InArduino[2] + "  " + InArduino[3] + "  " + InArduino[4] + "  ");
      // pcam.rotateX(-PI/4);
      // pcam.rotateX((InArduino[0]-512)/1024);
      //      float f = InArduino[0] - InArduinoAvant[0];
      //      if ((f > - 100) && (f < 100)) ArduinoRotateX = f / 500;
      //      else ArduinoRotateX = 0;
      //      // println("ArduinoRotateX = " + ArduinoRotateX);
      //      f = InArduino[1] - InArduinoAvant[1];
      //      if ((f > - 100) && (f < 100)) ArduinoRotateY = f / 500;
      //      else ArduinoRotateY = 0;
      //      // println("ArduinoRotateY = " + ArduinoRotateY);
      //      f = InArduino[2] - InArduinoAvant[2];
      //      if ((f > - 100) && (f < 100)) ArduinoRotateZ = f / 500;
      //      else ArduinoRotateZ = 0;
      //      // println("ArduinoRotateZ = " + ArduinoRotateZ);
      NumeroVoix = 9;
      if (InArduino[0] > 969) NumeroVoix = 9;
      else if (InArduino[0] > 855) NumeroVoix = 8;
      else if (InArduino[0] > 741) NumeroVoix = 7;
      else if (InArduino[0] > 627) NumeroVoix = 6;
      else if (InArduino[0] > 513) NumeroVoix = 5;
      else if (InArduino[0] > 399) NumeroVoix = 4;
      else if (InArduino[0] > 285) NumeroVoix = 3;
      else if (InArduino[0] > 171) NumeroVoix = 2;
      else if (InArduino[0] > 57) NumeroVoix = 1;
      println("NumeroVoix = " + NumeroVoix);
      if (NumeroVoix != NumeroVoixAvant) {
        switch(NumeroVoix) {
        case 1: 
          Nom = "kabyle";
          break;
        case 2: 
          Nom = "maore";
          break;
        case 3: 
          Nom = "drehu";
          break;
        case 4: 
          Nom = "cemuhi";
          break;
        case 5: 
          Nom = "occitan";
          break;
        case 6: 
          Nom = "guadeloupe";
          break;
        case 7: 
          Nom = "picard";
          break;
        case 8: 
          Nom = "reunion";
          break;
        case 9: 
          Nom = "franceA";
          break;
        default:
          Nom = "franceA";
          break;
        }
        println("Nom = " + Nom);  
        if (millis() > (Temps2 + 3000)) {
          println("millis() = " + millis());
          Fini2();
          Ouverture(Nom + ".xml");
          Temps2 = millis();
        }
      }
      NumeroVoixAvant = NumeroVoix;
    }
  }
}

boolean sketchFullScreen() {
  // Adding this method to your code will automatically start your sketch
  // in full screen mode, without having to use Sketch → Present.
  return true;
}

